#!/usr/bin/env node
module.exports =
/******/ (function(modules, runtime) { // webpackBootstrap
/******/ 	"use strict";
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		var threw = true;
/******/ 		try {
/******/ 			modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 			threw = false;
/******/ 		} finally {
/******/ 			if(threw) delete installedModules[moduleId];
/******/ 		}
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	__webpack_require__.ab = __dirname + "/";
/******/
/******/ 	// the startup function
/******/ 	function startup() {
/******/ 		// Load entry module and return exports
/******/ 		return __webpack_require__(92);
/******/ 	};
/******/ 	// initialize runtime
/******/ 	runtime(__webpack_require__);
/******/
/******/ 	// run startup
/******/ 	return startup();
/******/ })
/************************************************************************/
/******/ ({

/***/ 92:
/***/ (function(__unusedmodule, __unusedexports, __webpack_require__) {


const utils = __webpack_require__(543);
const deployment = __webpack_require__(294)

/**
 * Verifying GitHub action inputs
 * @param {*} data The data to verify the inputs of
 */
 async function verifyInputs(data) {
    if(!data.pkgName || data.pkgName === '')
        throw new Error('Missing input "pkg_name"');
    if(data.npm){
        if(!data.npm.token || data.npm.token === '')
            throw new Error('Mising input "npm_access_token"');
    }
    if(data.github){
        if(!data.github.token || data.github.token === '')
            throw new Error('Mising input "github_access_token"');
        if(!data.github.owner || data.github.owner === '')
            throw new Error('Mising input "github_owner"');
        if(!data.github.repo || data.github.repo === '')
            throw new Error('Mising input "github_repo"');
    }
}

(async () => {
    try {
        const cliArguments = process.argv.slice(3)
        const isTriggered = (process.argv[1].includes('deploy-pkg') || process.argv[1].includes('\\npm-package-deployer\\lib\\npm.index.js'));
        //Verifying the deploy CLI command was executed
        if(process.argv[0].includes('node') && isTriggered && process.argv.length >= 3) {
            const packageName = process.argv[2];
            if(packageName === '--help')
                utils.printHelp();
            else {
                const data = {
                    pkgName: packageName,
                    debug: cliArguments.find(arg => arg.includes('--debug')) !== undefined,
                    prettyPrint: cliArguments.find(arg => arg.includes('--pretty-print')) !== undefined,
                    dryRun: cliArguments.find(arg => arg.includes('--dry-run')) !== undefined
                }
                const npmToken = cliArguments.find(arg => arg.includes('--npm-access-token'));
                const npmRegistry = cliArguments.find(arg => arg.includes('--npm-registry'));
                const npmScope = cliArguments.find(arg => arg.includes('--npm-scope'));
                data.npm = npmToken !== undefined ? {
                    token: npmToken ? npmToken.split('=')[1]: undefined,
                    registry: npmRegistry ? npmRegistry.split('=')[1]: 'registry.npmjs.org',
                    scope: npmScope ? npmScope.split('=')[1]: ''
                }: undefined;
                const githubToken = cliArguments.find(arg => arg.includes('--github-access-token'));
                const githubOwner = cliArguments.find(arg => arg.includes('--github-owner'));
                const githubRepo = cliArguments.find(arg => arg.includes('--github-repo'));
                data.github = githubToken !== undefined ? {
                    owner: githubOwner ? githubOwner.split('=')[1]: undefined,
                    repo: githubRepo ? githubRepo.split('=')[1]: undefined,
                    token: githubToken ? githubToken.split('=')[1]: undefined
                }: undefined;

                console.log(data)
                //Verifying inputs
                verifyInputs(data);
                await deployment.deploy(data);
            }
        }
        else utils.printHelp()
    } catch (error) {
        console.log(error);
        throw Error(error);
    }
})();

/***/ }),

/***/ 129:
/***/ (function(module) {

module.exports = require("child_process");

/***/ }),

/***/ 294:
/***/ (function(__unusedmodule, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "deploy", function() { return deploy; });
const utils = __webpack_require__(543);
const github = __webpack_require__(790);
const npm = __webpack_require__(625);

/**
 * Deploying pkg version
 * @param {*} data The data passed to the deployment
 */
async function deploy(data) {
    //Configuration section
    let mainPublishVersion = undefined;
    await github.configureGitHub(data.pkgName)
    //In case we set a main package manager, we wil obtain it's next version.
    if(data.mainPackageManager) {
        mainPublishVersion = await getMainPublishVersion(data, data.mainPackageManager)
        await utils.execute(`echo "The main package manager ${data.mainPackageManager} has version ${mainPublishVersion}"`, data.debug)
    }
    //In case we set a release of an NPM package
    if(data.npm) {
        await npm.deployNpmRelease(data, mainPublishVersion);
    }
    //In case we set a release of a GitHub release
    if(data.github) {
        await github.deployGithubRelease(data, mainPublishVersion);
    }
}

/**
 * Retrieving the main publish version
 * @param {*} data The data of the action
 * @param {*} mainManagerName The main manager name.
 * @returns The next version of the main manager name
 */
async function getMainPublishVersion(data, mainManagerName) {
    let currentVersion = null;
    switch(mainManagerName) {
        case 'github':
            currentVersion = await github.getCurrentGitHubVersion(data);
            break;
        case 'npm':
            currentVersion = await npm.getCurrentVersion(data.pkgName, data.workingDirectory);
            break;
        default:
            break;
    }
    return utils.getNextVersion(currentVersion);
}

/***/ }),

/***/ 543:
/***/ (function(__unusedmodule, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "execute", function() { return execute; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "stringToBoolean", function() { return stringToBoolean; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "printHelp", function() { return printHelp; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getNextVersion", function() { return getNextVersion; });
const child_process = __webpack_require__(129);

/**
 * Executing a shell command
 * @param {*} command The command
 * @param {*} isDebug If to print extra debug logs. Default: false
 */
async function execute(command, isDebug = false) {
    return new Promise((done, failed) => {
        child_process.exec(command, (error, stdout, stderr) => {
            if (error !== null) failed(error)
            if(isDebug === 'true' || isDebug === true)
                console.log({ command, stdout, stderr })
            done({ stdout, stderr })
        })
    })
}

/**
 * Converting string value to boolean
 * @param {*} value The value given to convert to boolean
 * @returns A boolean
 */
function stringToBoolean(value) {
    return (value === 'false' || value === undefined) ? false: true;
}

/**
 * Printing the help message
 */
async function printHelp() {
    console.log(chalk.magenta('In order to deploy a version, run the following command:'))
    console.log(chalk.white('deploy-pkg <packageName> <optional additional cli args>'))
    console.log(chalk.white('additional parameters:'))
    console.log(chalk.white('--publish-original-output | Printing the original publish output'))
    console.log(chalk.white('--publish-pretty-output | Printing a pretified publish output'))
    console.log(chalk.white('for help, run deploy-pkg --help'))
    console.log(chalk.blueBright('If you liked our repo, please star it here https://github.com/danitseitlin/npm-package-deployer'))
}

/**
 * Retrieve the next version
 * @param {*} currentVersion The current version to upgrade from 
 * @returns The next version of a release
 */
function getNextVersion(currentVersion) {
    const split = currentVersion.split('.');
    const version = {
        major: parseInt(split[0]),
        minor: parseInt(split[split.length-2]),
        patch: parseInt(split[split.length-1])
    }
    if(version.patch < 9) version.patch++;
    else if(version.patch === 9 && version.minor < 9) {version.patch = 0; version.minor++}
    else if(version.patch === 9 && version.minor === 9 ) {version.patch = 0; version.minor = 0; version.major++;}
    return `${version.major}.${version.minor}.${version.patch}`
}

/***/ }),

/***/ 625:
/***/ (function(__unusedmodule, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "configureNPM", function() { return configureNPM; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getCurrentVersion", function() { return getCurrentVersion; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getUpgradeVersion", function() { return getUpgradeVersion; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getCliArguments", function() { return getCliArguments; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "doesPackageExist", function() { return doesPackageExist; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "parseDeployment", function() { return parseDeployment; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "deployNpmRelease", function() { return deployNpmRelease; });
const utils = __webpack_require__(543)

/**
 * Configurating NPM
 * @param {*} data The data of the NPM
 */
async function configureNPM(data) {
    await utils.execute(`echo "registry=https://registry.npmjs.org/" >> "${data.workingDirectory}/.npmrc"`, data.debug);
    if(data.scope !== '') {
        await utils.execute(`echo "@${data.scope}:registry=https://${data.registry}/${data.scope}" >> "${data.workingDirectory}/.npmrc"`, data.debug);
    }
    await utils.execute(`echo "//${data.registry}/:_authToken=${data.token}" >> "${data.workingDirectory}/.npmrc"`, data.debug);
}

/**
 * Retrieving the current version of the package
 * @param {*} pkgName The name of the package
 */
async function getCurrentVersion(pkgName, workingDirectory = './') {
    try {
        const currentVersion = await utils.execute(`cd ${workingDirectory} && npm info ${pkgName} version`);
        return currentVersion.stdout.replace('\n', '');
    }
    catch (err) {
        return '0.0.1'
    }
}

/**
 * Retrieving the version of the current package
 * @param {*} pkgName The name of the package
 * @param {*} cliArguments The additional CLI arguments
 */
async function getUpgradeVersion(pkgName, cliArguments) {
    if(await doesPackageExist(pkgName, cliArguments)) {
        const currentVersion = await getCurrentVersion(pkgName);
        const version = getNextVersion(currentVersion);
        return version;
    }
    return '0.0.1';
}

/***
 * Retrieving the args for the CLI commands
 * @param {*} data The given data of the deployment
 */
function getCliArguments(data) {
    let args = '';
    if(data.npm.registry && data.npm.registry !== 'registry.npmjs.org')
        args += ` --registry=https://${data.npm.registry}`;
    if(data.npm.scope && data.npm.scope !== '')
        args += ` --scope=@${data.npm.scope}`;
    if(data.dryRun === 'true' || data.dryRun === true)
        args += ` --dry-run`;
    return args;
}

/**
 * Checking if the pacakge exists in the relevant NPM registry
 * @param {*} pkgName The name of the package
 * @param {*} cliArguments The additional CLI arguments
 */
async function doesPackageExist(pkgName, cliArguments) {
    const arrayArguments = cliArguments.split(' ')
    const isScopedRegistry = arrayArguments.findIndex((item) => item.includes('--registry') && !item.includes('registry.npmjs.org')) !== -1;
    const isScope = arrayArguments.findIndex((item) => item.includes('--scope')) !== -1;

    if(!isScopedRegistry && !isScope) {
        const response = await utils.execute(`npm search ${pkgName}${cliArguments}`);
        const isExists = response.stdout.indexOf(`No matches found for "${pkgName}"`) === -1;
        return isExists;
    }
    else {
        console.log('Because of known NPM issues, we do not search for the package existence before deployment of Scoped packages.')
        return true;
    }
}

/**
 * Parsing the publish output to a more pretified version
 * @param output The publish output
 */
function parseDeployment(output) {
    const split = output.stderr.split('\n');
    const name = split.find(item => item.includes('name'))
    const version = split.find(item => item.includes('version'))
    const size = split.find(item => item.includes('package size'))
    const unpackedSize = split.find(item => item.includes('unpacked size'))
    const shasum = split.find(item => item.includes('shasum'))
    const integrity = split.find(item => item.includes('integrity'))
    const totalFiles = split.find(item => item.includes('total files'))
    const files = []
    const filesStartIndex = split.findIndex(item => item.includes('Tarball Contents'))
    const filesEndIndex = split.findIndex(item => item.includes('Tarball Details'))
    //Parsing only the files
    for(let i = filesStartIndex+1; i < filesEndIndex; i++) {
        files.push(split[i].split('B ')[1].replace(/ /g, '').replace('\n', ''));
    }
    //Building and returning the rest of the JS object
    return {
        files: files,
        name: (name !== undefined) ? name.replace(/  /g, '').split(':')[1]: null,
        version: (version !== undefined) ? version.replace(/  /g, '').split(': ')[1].replace(/ /g, ''): null,
        size: (size !== undefined) ? size.replace(/  /g, '').split(':')[1]: null,
        unpackedSize: (unpackedSize !== undefined) ? unpackedSize.replace(/  /g, '').split(': ')[1].replace(/ /g, ''): null,
        shasum: (shasum !== undefined) ? shasum.replace(/  /g, '').split(':')[1]: null,
        integrity: (integrity !== undefined) ? integrity.replace(/  /g, '').split(': ')[1]: null,
        totalFiles: (totalFiles !== undefined) ? parseInt(totalFiles.replace(/  /g, '').split(': ')[1]): null,
    }
}

/**
 * Deploying an NPM package
 * @param {*} data The data of the action
 * @param {*} mainPublishVersion The main publish version. if available.
 */
async function deployNpmRelease(data, mainPublishVersion) {
    let pkgName = data.pkgName;
    if(data.npm.scope && data.npm.scope !== ''){
        pkgName = `@${data.npm.scope}/${data.pkgName}`;
        data.pkgName = pkgName;
    }
    await configureNPM({
        token: data.npm.token,
        registry: data.npm.registry,
        scope: data.npm.scope,
        workingDirectory: data.workingDirectory,
        debug: data.debug
    });
    //NPM Package deployment section
    const cliArguments = getCliArguments(data);
    await utils.execute(`echo "args: ${cliArguments}"`, data.debug)
    const currentVersion = mainPublishVersion ? mainPublishVersion: await getCurrentVersion(pkgName, data.workingDirectory)
    await utils.execute(`echo "current ver: ${JSON.stringify(currentVersion)}"`, data.debug)
    const packageExists = await doesPackageExist(pkgName, cliArguments);
    await utils.execute(`echo "package exists? ${packageExists}"`, data.debug);
    const publishVersion = packageExists ? utils.getNextVersion(currentVersion): '0.0.1';
    if(packageExists) {
        await utils.execute(`echo "new ver: ${publishVersion}"`, data.debug);
        console.log(`Upgrading ${pkgName}@${currentVersion} to version ${pkgName}@${publishVersion}`);
    }
    else {
        console.log(`Publishing new package ${pkgName}@${publishVersion}`);
    }
    await utils.execute(`cd ${data.workingDirectory} && ls && npm version ${publishVersion} --allow-same-version${cliArguments}`, data.debug);
    const publish = await utils.execute(`cd ${data.workingDirectory} && npm publish${cliArguments}`, data.debug);
    console.log('==== Publish Output ====')
    if(data.prettyPrint === 'true' || data.prettyPrint === true) {
        const prettyPublish = parseDeployment(publish);
        const { files, ...rest } = prettyPublish
        for(const item in rest) {
            console.log(`${item}: ${rest[item].toString()}`)
        }
        console.log(`files: ${files.toString().replace(/,/g, ', ')}`)
        console.log('========================')
    }
    else {
        console.log(publish)
    }
}

/***/ }),

/***/ 790:
/***/ (function(__unusedmodule, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "configureGitHub", function() { return configureGitHub; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "releaseGitHubVersion", function() { return releaseGitHubVersion; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getGitHubVersions", function() { return getGitHubVersions; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getCurrentGitHubVersion", function() { return getCurrentGitHubVersion; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "deployGithubRelease", function() { return deployGithubRelease; });
const utils = __webpack_require__(543);

/**
 * Configurating GitHub
 * @param {*} pkgName The name of the pkg
 */
async function configureGitHub(pkgName) {
    await utils.execute(`git config --global user.name "Deploy BOT" && git config --global user.email "bot@${pkgName}.com"`)
}

/**
 * Releasing a new GitHub release
 * @param {*} data The data of the GitHub release
 */
async function releaseGitHubVersion(data) {
    const tagName = `v${data.version}`;
    const body = `Release of ${tagName}`;
    console.log(`Releasing GitHub version ${tagName}`)
    if(!data.dryRun) {
        const res = await utils.execute(`curl -H 'Authorization: token ${data.token}' --data '{"tag_name": "${tagName}","target_commitish": "${data.branch}","name": "${tagName}","body": "${body}","draft": ${data.draft},"prerelease": ${data.preRelease}' https://api.github.com/repos/${data.owner}/${data.repo}/releases`)
        if(res.stdout === '')
            throw new Error(res.stderr)
    }
}

/**
 * Retrieving all the GitHub versions
 * @param {*} data The data of GitHub
 * @returns An array object of the GitHub releases
 */
async function getGitHubVersions(data) {
    const res = (await utils.execute(`curl -H 'Authorization: token ${data.token}' https://api.github.com/repos/${data.owner}/${data.repo}/releases`)).stdout;
    return JSON.parse(res)
}

/**
 * Retrieving the current version of the package
 * @param {*} data The data of GitHub
 * @returns The current version of the latest GitHub release
 */
async function getCurrentGitHubVersion(data) {
    const githubReleases = await getGitHubVersions(data.github);
    const githubRelease = githubReleases[0]
    await utils.execute(`echo "The latest github version ${JSON.stringify(githubRelease)}"`, data.debug);
    if(!githubRelease.tag_name) {
        console.debug(githubRelease)
        throw new Error('tag_name value is undefined.')
    }
    const currentVersion = githubRelease.tag_name.replace('v', '');
    return currentVersion;
}

/**
 * Deploying a GitHub release
 * @param {*} data The data of the action
 * @param {*} mainPublishVersion The main publish version. if available.
 */
async function deployGithubRelease(data, mainPublishVersion) {
    //version, branch, draft, preRelease
    const currentVersion = mainPublishVersion ? mainPublishVersion: await getCurrentGitHubVersion(data);
    const publishVersion = utils.getNextVersion(currentVersion);
    await releaseGitHubVersion({
        owner: data.github.owner,
        repo: data.github.repo,
        token: data.github.token,
        version: publishVersion,
        branch: 'master',
        draft: false,
        preRelease: false,
        debug: data.debug,
        dryRun: data.dryRun
    })
}

/***/ })

/******/ },
/******/ function(__webpack_require__) { // webpackRuntimeModules
/******/ 	"use strict";
/******/ 
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/define property getter */
/******/ 	!function() {
/******/ 		// define getter function for harmony exports
/******/ 		var hasOwnProperty = Object.prototype.hasOwnProperty;
/******/ 		__webpack_require__.d = function(exports, name, getter) {
/******/ 			if(!hasOwnProperty.call(exports, name)) {
/******/ 				Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ }
);